﻿using Data.DAO;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace data
{
    public class RemoteDatabaseContext: DbContext
    {
        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseNpgsql("Host=localhost;port=5432;Password=admin;Username=postgres;Database=semesterWork");
        }

        //protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        //{
        //    optionsBuilder.UseNpgsql("Host=45.67.56.214; Port=5454; Username=user3; Password=VOTfZ8PQ; Database=user3");
        //}


        public DbSet<Group> Groups { get; set; }
        public DbSet<Student> Students { get; set; }
        public DbSet<Attendance> Attendances { get; set; }
        public DbSet<GroupSubject> GroupSubjects { get; set; }
        public DbSet<Semester> Semesters { get; set; }
        public DbSet<Subject> Subjects { get; set; }
        public DbSet<Visit> Visits { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Student>().HasKey(it => it.StudentId);
            modelBuilder.Entity<Group>().HasKey(it => it.GroupId);
            modelBuilder.Entity<GroupSubject>().HasKey(it => it.GroupSubjectId);
            modelBuilder.Entity<Semester>().HasKey(it => it.SemesterId);
            modelBuilder.Entity<Visit>().HasKey(it => it.VisitId);
            modelBuilder.Entity<Subject>().HasKey(it => it.SubjectId);
            modelBuilder.Entity<Attendance>().HasKey(it => it.AttendanceId);

            modelBuilder.Entity<Student>().Property(it => it.StudentId).ValueGeneratedOnAdd();
            modelBuilder.Entity<Group>().Property(it => it.GroupId).ValueGeneratedOnAdd();
            modelBuilder.Entity<GroupSubject>().Property(it => it.GroupSubjectId).ValueGeneratedOnAdd();
            modelBuilder.Entity<Semester>().Property(it => it.SemesterId).ValueGeneratedOnAdd();
            modelBuilder.Entity<Visit>().Property(it => it.VisitId).ValueGeneratedOnAdd();
            modelBuilder.Entity<Subject>().Property(it => it.SubjectId).ValueGeneratedOnAdd();
            modelBuilder.Entity<Attendance>().Property(it => it.AttendanceId).ValueGeneratedOnAdd();
        }
    }
}
